

if exists ( Select * FROM sysobjects where id = object_id ( 'dbo.A_CallCenter_Temp_CreateTables' ) )
	Drop procedure dbo.A_CallCenter_Temp_CreateTables
GO

Create  Procedure [dbo].[A_CallCenter_Temp_CreateTables]
as
begin
	If not exists ( Select * From oktell_cc_temp..sysobjects where id = object_id ( '[oktell_cc_temp].[dbo].[A_Cube_CC_EffortConnections]' ) )
	begin
	Create table [oktell_cc_temp].[dbo].[A_Cube_CC_EffortConnections] 
	( 
		IdProject	uniqueidentifier NOT NULL,
		IdTask 		uniqueidentifier NOT NULL,
		IsOutput	bit NOT NULL,
		IdEffort	uniqueidentifier NOT NULL,
		IdOperator 	uniqueidentifier,
		IdInList	int NOT NULL,
		AbonentNumber 	nvarchar ( 20 ) NOT NULL,
		CallResult	int NOT NULL,
		CallResultInfo	nvarchar ( 100 ) Not NULL,
		DateTimeStart 	DateTime NOT NULL, 
		DateStart 	DateTime NOT NULL, 
		TimeStart 	DateTime NOT NULL,
		DateTimeStop	DateTime Not Null,
		IdConn		uniqueidentifier,
		IdChain 	uniqueidentifier,	
		IdAUser		uniqueidentifier,
		IdBUser		uniqueidentifier,
		IdExtLine 	uniqueidentifier NOT NULL,
		LenTime 	float NOT NULL, 
		LenQueue 	float NOT NULL,
		IsBetweenOp	bit,
		OpponentInfo 	nvarchar ( 200 ),
		IsHandled 	bit NOT NULL,
		IsSuccess	bit Not NULL,
		IsRecorded	bit,
		IdRecDir	int,
		ALineNum	nvarchar ( 5 ),
		BLineNum	nvarchar ( 5 ),
		--ARecFile	nvarchar ( 100 ),
		--BRecFile 	nvarchar ( 100 ),
		UserResult 	int
	)	
	end


	If not exists ( Select * From oktell_cc_temp..sysobjects where id = object_id ( '[oktell_cc_temp].[dbo].[A_Cube_CC_OperatorStates]' ) )
	begin
	Create table [oktell_cc_temp].[dbo].[A_Cube_CC_OperatorStates] 
	( 		
		Id		int identity ( 1, 1 ) not null primary key,
		IdTask 		uniqueidentifier,
		IsOutput	bit,	
		IdOperator 	uniqueidentifier NOT NULL,
		CallResult	int,
		State		int Not Null,
		DateTimeStart 	DateTime NOT NULL, 
		DateStart 	DateTime NOT NULL, 
		TimeStart 	DateTime NOT NULL,
		DateTimeStop 	DateTime NOT NULL, 
		LenTime 	float NOT NULL,
		ICode 		int NULL	
	)
	end


	If not exists ( Select * From oktell_cc_temp..sysobjects where id = object_id ( '[oktell_cc_temp].[dbo].[A_Cube_CC_CallQueue]' ) )
	begin
	Create table [oktell_cc_temp].[dbo].[A_Cube_CC_CallQueue] 
	( 
		IdTask 		uniqueidentifier NOT NULL,
		IdProject	uniqueidentifier Not NULL,
		DateTimeStart 	DateTime NOT NULL, 
		DateStart 	DateTime NOT NULL, 
		TimeStart 	DateTime NOT NULL,
		CountQueue	int Not Null,
		CountOperator	int Not Null,
		CountTalking	int Not Null,
		elt1WaitStart	DateTime NOT NULL,
		elt1WaitSec	int Not null,
	)
	end



	If not exists ( Select * From oktell_cc_temp..sysobjects where id = object_id ( '[oktell_cc_temp].[dbo].[A_Cube_CC_Cat_OperatorStateTypes]' ) )
	Create table [oktell_cc_temp].[dbo].[A_Cube_CC_Cat_OperatorStateTypes] 
	(
		Id int not null primary key,
		Name nvarchar ( 500 ) not null
	)

	If not exists ( Select * From oktell_cc_temp..sysobjects where id = object_id ( '[oktell_cc_temp].[dbo].[A_Cube_CC_Cat_TaskResultTypes]' ) )
	Create table [oktell_cc_temp].[dbo].[A_Cube_CC_Cat_TaskResultTypes] 
	(
		Id int not null primary key,
		Name nvarchar ( 500 ) not null
	)

	If not exists ( Select * From oktell_cc_temp..sysobjects where id = object_id ( '[oktell_cc_temp].[dbo].[A_Cube_CC_Cat_Task]' ) )
	Create table [oktell_cc_temp].[dbo].[A_Cube_CC_Cat_Task] 
	(
		Id uniqueidentifier not null primary key,
		Name nvarchar ( 500 ) not null
	)

	If not exists ( Select * From oktell_cc_temp..sysobjects where id = object_id ( '[oktell_cc_temp].[dbo].[A_Cube_CC_Cat_Project]' ) )
	Create table [oktell_cc_temp].[dbo].[A_Cube_CC_Cat_Project] 
	(
		Id uniqueidentifier not null primary key,
		Name nvarchar ( 500 ) not null
	)

	If not exists ( Select * From oktell_cc_temp..sysobjects where id = object_id ( '[oktell_cc_temp].[dbo].[A_Cube_CC_Cat_OperatorInfo]' ) )
	Create table [oktell_cc_temp].[dbo].[A_Cube_CC_Cat_OperatorInfo] 
	(
		Id uniqueidentifier not null primary key,
		Name nvarchar ( 500 ),
		p0 int,	p1 int, p2 int, p3 int, p4 int, p5 int,
		s0 int,	s1 int, s2 int, s3 int, s4 int, s5 int,
		LastDT DateTime

	)

	if not exists ( Select * FROM oktell_cc_temp..sysobjects Where Id = object_id ( '[oktell_cc_temp].[dbo].[A_Sms]' ) )
	Create table oktell_cc_temp.dbo.A_Sms
	(	
		Id int identity ( 1, 1 ) not null primary key,
	--	IdGuid uniqueidentifier not null,
		Received bit not null,
		DT DateTime not null,
		Sender nvarchar ( 100 ) not null,
		Receiver nvarchar ( 100 ) not null,
		SmsText nvarchar ( 2000 ) not null,
		PushId int null,
		Delivered bit null,
		DeliveredDT DateTime null
	)

end
GO




if exists ( Select * FROM sysobjects where id = object_id ( 'dbo.A_CallCenter_Temp_ChangeTables' ) )
	Drop procedure dbo.A_CallCenter_Temp_ChangeTables
GO

Create procedure dbo.A_CallCenter_Temp_ChangeTables
	@dir int,
	@id int,
	@text nvarchar ( 500 )
as
begin
	--           CCTemp
	if ( @dir = 1 )
	begin
		Update [oktell_cc_temp].[dbo].[A_Cube_CC_Cat_OperatorStateTypes] 
		Set Name = @text Where Id = @id

		if ( @@rowcount = 0 )
			Insert into [oktell_cc_temp].[dbo].[A_Cube_CC_Cat_OperatorStateTypes] 
			( Id, Name ) Values ( @id, @text )
	end

	else if ( @dir = 2 )
	begin
		Update [oktell_cc_temp].[dbo].[A_Cube_CC_Cat_TaskResultTypes] 
		Set Name = @text Where Id = @id

		if ( @@rowcount = 0 )
			Insert into [oktell_cc_temp].[dbo].[A_Cube_CC_Cat_TaskResultTypes] 
			( Id, Name ) Values ( @id, @text )
	end
end
GO




if exists ( Select * FROM sysobjects where id = object_id ( 'dbo.A_CallCenter_Temp_GetCheckLocalize' ) )
	Drop procedure dbo.A_CallCenter_Temp_GetCheckLocalize
GO

Create procedure dbo.A_CallCenter_Temp_GetCheckLocalize
	@dir int,
	@id int,
	@text nvarchar ( 500 )
as
begin
	Declare @tst nvarchar ( 500 )
	Set @tst = NULL

	--     
	if ( @dir = 1 )
	begin
		Select @tst = Name
		From [oktell_cc_temp].[dbo].[A_Cube_CC_Cat_OperatorStateTypes] 
		Where Id = @id		
	end

	else if ( @dir = 2 )
	begin
		Select @tst = Name
		From [oktell_cc_temp].[dbo].[A_Cube_CC_Cat_TaskResultTypes] 
		Where Id = @id		
	end


	--     , 
	--     > 0      

	if ( @@rowcount = 0 )
		return 1

	else if ( @tst != @text )
		return 2

	else
		return 0
end
GO