
if exists ( Select * FROM sysobjects Where id = object_id ( 'dbo.Tmp_A_VoiceMail' ) )
	Drop table dbo.Tmp_A_VoiceMail
GO

CREATE TABLE dbo.[Tmp_A_VoiceMail] 
(
	[Id] [uniqueidentifier] NOT NULL PRIMARY KEY,
	[RecieverId] [uniqueidentifier] NULL ,
	[RecieverIsGroup] [int] NULL ,
	[SentTime] [datetime] NULL ,
	[RecievedTime] [datetime] NULL ,
	[FilePath] [ntext],
	[Info] [ntext],
	[CallerId] [nvarchar] (500),
	[IsShown] [int] NULL ,
	[WhoRecieved] [uniqueidentifier] NULL 
) ON [PRIMARY]
GO

IF EXISTS(SELECT * FROM dbo.A_VoiceMail)
	 EXEC('INSERT INTO dbo.Tmp_A_VoiceMail (ID, RecieverId, RecieverIsGroup, SentTime, RecievedTime, FilePath, Info, CallerId, IsShown, WhoRecieved)
		SELECT ID, RecieverId, RecieverIsGroup, SentTime, RecievedTime, FilePath, Info, CallerId, IsShown, WhoRecieved FROM dbo.A_VoiceMail WITH (HOLDLOCK TABLOCKX)')
GO

DROP TABLE dbo.A_VoiceMail
GO

EXECUTE sp_rename N'dbo.Tmp_A_VoiceMail', N'A_VoiceMail', 'OBJECT'
GO


if exists ( Select * from sysobjects where id = object_id ( 'dbo.A_VoiceMail_SetListened' ) )
	Drop procedure [dbo].[A_VoiceMail_SetListened]
GO

Create procedure dbo.A_VoiceMail_SetListened
	@userid uniqueidentifier,
	@mailid uniqueidentifier,
	@dtnow DateTime = null
as
begin
	if ( @dtnow is NULL )
		Set @dtnow = GetDate()

	Update A_VoiceMail
	Set 	
		RecievedTime = @dtnow,
		WhoRecieved = @userid,
		IsShown = 1
	Where Id = @mailid
		And IsShown = 0
end
GO


if exists ( Select * from sysobjects where id = object_id ( 'dbo.A_VoiceMail_GetDataForUser' ) )
	Drop procedure [dbo].[A_VoiceMail_GetDataForUser]
GO

Create procedure [dbo].[A_VoiceMail_GetDataForUser]
	@userid			uniqueidentifier,
	@onlynew		int
as
begin

/*
	Update A_VoiceMail
	Set RecievedTime = GetDate (),
		WhoRecieved = @userid	
	Where RecieverId = @userid
		and IsShown = 0;
*/


	Select vm.Id, FilePath, IsShown, SentTime, RecievedTime, vm.Info, CallerId, WhoRecieved, u.Name
	From A_VoiceMail vm
		left join A_Users u on vm.WhoRecieved = u.Id
	Where ( RecieverId = @userid )
		And (( IsShown = 0 ) or ( @onlynew = 0 ))
	Order By SentTime
	

/*
	Update A_VoiceMail
	Set IsShown = 1
	Where RecieverId = @userid
		and IsShown = 0;
*/
	
end
GO