if exists ( Select * from sysobjects where id = object_id ( 'dbo.A_Admin_Rule_Save' ) )
	Drop procedure dbo.A_Admin_Rule_Save
GO

Create Procedure dbo.A_Admin_Rule_Save
	@id uniqueidentifier,
	@name nvarchar ( 100 ), 
	@priority int,
	@type int = 0
as
begin

	Delete 
	From A_RuleRecords 
	Where RuleId = @id


	Update A_Rules 
	Set 	Name = @name, 
		Type = @type,
		Priority = @priority
	Where ID = @id


	if ( @@rowcount = 0 )
	begin
		Insert 
		Into A_Rules 
			( ID, Name, Type, Priority ) 
		Values 
			( @id, @name, @type, @priority )
	end

end
GO


if exists ( Select * from sysobjects where id = object_id ( 'dbo.A_View_Rule' ) )
	Drop view dbo.A_View_Rule
GO

Create View dbo.A_View_Rule
as
	Select  Top 100 Percent
		r.ID, 
		r.Name, 
		rr.InnerAddressType, 
		rr.ReactID, 
                rr.StartTime, 
		rr.FinishTime, 
		r.Priority,
		rr.Id as rrid,
		rr.Account,
		r.Type
	
	From  dbo.A_RuleRecords rr
		Inner Join dbo.A_Rules r On rr.RuleID = r.Id
	Order By r.Priority Desc, r.Id, rr.StartTime

GO