if exists ( select * From sysobjects where id = object_id ( 'dbo.A_DB_ClearForeign' ))
	Drop procedure [dbo].[A_DB_ClearForeign]
GO

Create procedure [dbo].[A_DB_ClearForeign]
	@simpletablename nvarchar ( 500 )
as
begin

    ------
    --   Foreign Keys (      )
    ------

	Declare @tablename varchar ( 500 )
	Declare @sql nvarchar(1000)

	Declare @cnstrname varchar(500)
	Declare @subtab varchar ( 500 )

	Select @simpletablename = s.name, @tablename = '[' + su.name + '].[' + s.name + ']'
	From sysobjects s
		Inner join sysusers su on s.uid = su.uid
	Where s.id = object_id ( @simpletablename )

    ------
    --  
    ------

	Declare tcursor Cursor For 
		Select s.name, '[' + su.name + '].[' + s1.name + ']'
		From sysobjects s
			inner join sysforeignkeys sfk on s.id = sfk.constid	
			inner join sysobjects s1 on s.parent_obj = s1.id
			inner join sysusers su on s1.uid = su.uid
		Where sfk.fkeyid = object_id ( @tablename )

	Open tcursor
	Fetch Next From tcursor Into @cnstrname, @subtab

	While ( @@fetch_status = 0 ) Begin

		Set @sql = ' ALTER TABLE ' + @subtab + 
			' DROP CONSTRAINT ' + @cnstrname
		Exec sp_executesql @stmt =@sql
		Print @sql

		Fetch Next From tcursor Into @cnstrname, @subtab
	End

	Close tcursor
	Deallocate tcursor

    ------
    --  
    ------

	Declare tcursor Cursor For 
		Select s.name, '[' + su.name + '].[' + s1.name + ']'
		From sysobjects s
			inner join sysforeignkeys sfk on s.id = sfk.constid	
			inner join sysobjects s1 on s.parent_obj = s1.id
			inner join sysusers su on s1.uid = su.uid
		Where sfk.rkeyid = object_id ( @tablename )
	
	Open tcursor
	Fetch Next From tcursor Into @cnstrname, @subtab

	While ( @@fetch_status = 0 ) Begin

		Set @sql = ' ALTER TABLE ' + @subtab + 
			' DROP CONSTRAINT ' + @cnstrname
		Exec sp_executesql @stmt =@sql
		Print @sql

		Fetch Next From tcursor Into @cnstrname, @subtab
	End

	Close tcursor
	Deallocate tcursor
End
GO



if exists ( Select * FROM sysobjects where id=object_id ( 'dbo.A_DB_ClearConstraints' ))
	Drop procedure dbo.A_DB_ClearConstraints
GO

Create procedure [dbo].[A_DB_ClearConstraints]
	@simpletablename nvarchar ( 500 )
as
begin
  	--     (  )
	--    ?

	--   ,     
	exec dbo.A_DB_ClearForeign @simpletablename
End
GO



if exists ( Select * FROM sysobjects where id=object_id ( 'dbo.A_DB_ClearConstraintsAll' ))
	Drop procedure dbo.A_DB_ClearConstraintsAll
GO

Create procedure [dbo].[A_DB_ClearConstraintsAll]
	@simpletablename nvarchar ( 500 )
as
begin
    ------
    --      (  )
    --    
    ------

    ------
    --    ForeignKeys,      
    ------

	exec dbo.A_DB_ClearForeign @simpletablename

    ------
    --    
    ------

	Declare @tablename varchar ( 500 )
	Declare @sql nvarchar(1000)
	
	Select @simpletablename = s.name, @tablename = '[' + su.name + '].[' + s.name + ']'
	From sysobjects s
		Inner join sysusers su on s.uid = su.uid
	Where s.id = object_id ( @simpletablename )

	Declare @cnstrname varchar(500)
	Declare @subtab varchar ( 500 )

	Declare tcursor Cursor For 
		Select s.name, '[' + su.name + '].[' + s1.name + ']'
		From sysobjects s
			Inner join sysobjects s1 on s1.Id = s.parent_obj
			inner join sysusers su on s1.uid = su.uid
		Where ( s.type = 'K' )
			and s.parent_obj = object_id ( @tablename )
	
	Open tcursor
	Fetch Next From tcursor Into @cnstrname, @subtab

	While ( @@fetch_status = 0 ) Begin

		Set @sql = ' ALTER TABLE ' + @subtab + 
			' DROP CONSTRAINT ' + @cnstrname
		Exec sp_executesql @stmt =@sql
		Print @sql

		Fetch Next From tcursor Into @cnstrname, @subtab
	End

	Close tcursor
	Deallocate tcursor

End
GO



if exists ( Select * FROM sysobjects where id=object_id ( 'dbo.A_DB_ClearIndexes' ))
	Drop procedure dbo.A_DB_ClearIndexes
GO

Create procedure [dbo].[A_DB_ClearIndexes]
	@simpletablename nvarchar ( 500 )
as
begin
    ------
    --      
    ------

	Declare @tablename varchar ( 500 )
	Declare @sql nvarchar(1000)
	
	Select @simpletablename = s.name, @tablename = '[' + su.name + '].[' + s.name + ']'
	From sysobjects s
		Inner join sysusers su on s.uid = su.uid
	Where s.id = object_id ( @simpletablename )
	

	Declare tcursor Cursor For 
		Select '[' + name + ']'
		From sysindexes 
		Where id = object_id ( @tablename ) 
			and impid >= 0 /*status!=0*/ 
			and name not like '_WA%' 
			and name not like 'PK_%'

	Declare @ind_name varchar(500)

	Open tcursor
	Fetch Next From tcursor Into @ind_name

	While ( @@fetch_status = 0 ) Begin

		Set @sql = 'drop index ' + @tablename + '.' + @ind_name
		Exec sp_executesql @stmt = @sql

		Fetch Next From tcursor Into @ind_name
	End

	Close tcursor
	Deallocate tcursor
End
GO



if exists ( Select * From sysobjects Where id = object_id ( 'dbo.A_DB_DropTable' ) )
	Drop procedure dbo.A_DB_DropTable
GO

Create procedure dbo.A_DB_DropTable
	@simplename nvarchar ( 500 )
as
begin
	Exec A_DB_ClearIndexes @simplename
	Exec A_DB_ClearConstraints @simplename
	
	

	Declare @sqltext nvarchar(4000)	
	Declare @fullname nvarchar(500)

	Select @simplename = s.name, @fullname = '[' + su.name + '].[' + s.name + ']'
	From sysobjects s
		Inner join sysusers su on s.uid = su.uid
	Where s.id = object_id ( @simplename )	


	Set @sqltext = ' If exists ( select * from sysobjects where id = object_id ( ''' + @fullname + ''' ) and OBJECTPROPERTY(id, N''IsUserTable'') = 1)
	    Drop Table ' + @fullname + ' '

	Exec sp_executesql @sqltext
end
GO



if exists ( Select * From sysobjects Where id = object_id ( 'dbo.A_DB_DropObject' ) )
	Drop procedure dbo.A_DB_DropObject
GO

Create procedure dbo.A_DB_DropObject
	@simplename nvarchar ( 500 )
as
begin
	Exec A_DB_ClearIndexes @simplename
	Exec A_DB_ClearConstraints @simplename


	Declare @sqltext nvarchar(4000)	
	Declare @fullname nvarchar(500)

	Select @simplename = s.name, @fullname = '[' + su.name + '].[' + s.name + ']'
	From sysobjects s
		Inner join sysusers su on s.uid = su.uid
	Where s.id = object_id ( @simplename )	


	Set @sqltext = ' If exists ( select * from sysobjects where id = object_id ( ''' + @fullname + ''' ) and OBJECTPROPERTY(id, N''IsUserTable'') = 1)
	    Drop Table ' + @fullname + ' '

	Exec sp_executesql @sqltext

	Set @sqltext = ' If exists ( select * from sysobjects where id = object_id ( ''' + @fullname + ''' ) and OBJECTPROPERTY(id, N''IsView'') = 1)
	    Drop View ' + @fullname + ' '

	Exec sp_executesql @sqltext

	Set @sqltext = ' If exists ( select * from sysobjects where id = object_id ( ''' + @fullname + ''' ) and OBJECTPROPERTY(id, N''IsProcedure'') = 1)
	    Drop Procedure ' + @fullname + ' '

	Exec sp_executesql @sqltext
end
GO


if exists ( Select * From sysobjects Where id = object_id ( 'dbo.A_DB_CopyDataToSameTable_ColDest' ) )
	Drop procedure dbo.A_DB_CopyDataToSameTable_ColDest
GO

Create procedure dbo.A_DB_CopyDataToSameTable_ColDest
	@srcsimplename nvarchar ( 500 ),
	@destdatabase nvarchar ( 500 ),
	@destsimplename nvarchar ( 500 )
as
begin
	
   ------
   --     ,   .
   --   , identity     .
   --    - (       )
   ------

   ------
   --    
   ------

	Declare @sqltext nvarchar(4000)
	Declare @srctablename nvarchar(500), @desttablename nvarchar(500)
	
	Select @srcsimplename = s.name, @srctablename = '[' + su.name + '].[' + s.name + ']'
	From sysobjects s
		Inner join sysusers su on s.uid = su.uid
	Where s.id = object_id ( @srcsimplename )

	Set @sqltext = '

	Select s.name, ''[' + @destdatabase + '].'' + ''['' + su.name + ''].['' + s.name + '']''
	From [' + @destdatabase + ']..sysobjects s
		Inner join [' + @destdatabase + ']..sysusers su on s.uid = su.uid
	Where s.id = object_id ( ''[' + @destdatabase + ']..[' + @destsimplename + ']'' ) '

	if exists ( select * from tempdb..sysobjects where id = object_id ( 'tempdb..#tk6683982' ))
	    Drop table #tk6683982

	Create table #tk6683982 ( simplename nvarchar(500), fullname nvarchar(1000) )

	Insert into #tk6683982 
	    Exec sp_executesql @sqltext

	Select @destsimplename = simplename, @desttablename = fullname
	From #tk6683982

 	Drop table #tk6683982


   ------
   --     
   ------

	Declare @columns nvarchar(4000)
	Set @columns = ''

    	Set @sqltext = '

	Declare @name nvarchar(500)
	Declare @columns nvarchar(4000)

	Set @columns = ''''

	Declare crs Cursor LOCAL FAST_FORWARD For 
	   Select name 
	   From [' + @destdatabase + ']..syscolumns
	   Where id = object_id ( ''' + @desttablename + ''' )
	   Order by colid
	
	Open crs
	Fetch Next From crs Into @name

	While ( @@fetch_status = 0 ) begin
	   if ( @columns = '''' )
	      Set @columns = ''['' + @name + '']''
	   else
	      Set @columns = @columns + '', ['' + @name + '']''

    	   Fetch Next From crs Into @name		
	end

   	Close crs
	Deallocate crs

	Select @columns '

	if exists ( select * from tempdb..sysobjects where id = object_id ( 'tempdb..#tk6683983' ))
	    Drop table #tk6683983

	Create table #tk6683983 ( columnnames nvarchar(4000) )

	Insert into #tk6683983 
	    Exec sp_executesql @sqltext

	Select @columns = columnnames
	From #tk6683983

 	Drop table #tk6683983

   ------
   --  
   ------
	
	Set @sqltext = '
		if exists ( select * from sysobjects where id = object_id ( ''' + @srctablename + ''' ) and OBJECTPROPERTY(id, N''IsUserTable'') = 1) 
		begin
 		   Declare @hasid bit
		   Set @hasid = 0

		   Truncate table ' + @desttablename + '

		   if exists ( select * from [' + @destdatabase + '].dbo.syscolumns where id = object_id ( ''' + @desttablename + ''' ) and status = 128 )
		      Set @hasid = 1

		   if ( @hasid = 1)
		      Set identity_insert ' + @desttablename + ' on

		   Insert Into ' + @desttablename + ' (' + @columns + ') 
	  	      select ' + @columns + ' from ' + @srctablename + ' 

		   if ( @hasid = 1)
		      Set identity_insert ' + @desttablename + ' off
		end '
	
	Exec sp_executesql @sqltext
end
GO


if exists ( Select * From sysobjects Where id = object_id ( 'dbo.A_DB_CopyDataToSameTable_ColSrc' ) )
	Drop procedure dbo.A_DB_CopyDataToSameTable_ColSrc
GO

Create procedure dbo.A_DB_CopyDataToSameTable_ColSrc
	@srcsimplename nvarchar ( 500 ),
	@destdatabase nvarchar ( 500 ),
	@destsimplename nvarchar ( 500 )
as
begin
	
    ------
   --     ,   .
   --   , identity     .
   --    - (       )
   ------

   ------
   --    
   ------

	Declare @sqltext nvarchar(4000)
	Declare @srctablename nvarchar(500), @desttablename nvarchar(500)
	
	Select @srcsimplename = s.name, @srctablename = '[' + su.name + '].[' + s.name + ']'
	From sysobjects s
		Inner join sysusers su on s.uid = su.uid
	Where s.id = object_id ( @srcsimplename )

	Set @sqltext = '

	Select s.name, ''[' + @destdatabase + '].'' + ''['' + su.name + ''].['' + s.name + '']''
	From [' + @destdatabase + ']..sysobjects s
		Inner join [' + @destdatabase + ']..sysusers su on s.uid = su.uid
	Where s.id = object_id ( ''[' + @destdatabase + ']..[' + @destsimplename + ']'' ) '

	if exists ( select * from tempdb..sysobjects where id = object_id ( 'tempdb..#tk6683982' ))
	    Drop table #tk6683982

	Create table #tk6683982 ( simplename nvarchar(500), fullname nvarchar(1000) )

	Insert into #tk6683982 
	    Exec sp_executesql @sqltext

	Select @destsimplename = simplename, @desttablename = fullname
	From #tk6683982

 	Drop table #tk6683982


   ------
   --     
   ------
	
	Declare @name nvarchar(500)
	Declare @columns nvarchar(4000)

	Set @columns = ''

	Declare crs Cursor LOCAL FAST_FORWARD For 
	   Select name 
	   From syscolumns
	   Where id = object_id ( @srctablename  )
	   Order by colid
	
	Open crs
	Fetch Next From crs Into @name

	While ( @@fetch_status = 0 ) begin
	   if ( @columns = '' )
	      Set @columns = '[' + @name + ']'
	   else
	      Set @columns = @columns + ', [' + @name + ']'

    	   Fetch Next From crs Into @name		
	end

   	Close crs
	Deallocate crs

   ------
   --  
   ------
	
	Set @sqltext = '
		if exists ( select * from sysobjects where id = object_id ( ''' + @srctablename + ''' ) and OBJECTPROPERTY(id, N''IsUserTable'') = 1) 
		begin
 		   Declare @hasid bit
		   Set @hasid = 0

		   Truncate table ' + @desttablename + '

		   if exists ( select * from [' + @destdatabase + '].dbo.syscolumns where id = object_id ( ''' + @desttablename + ''' ) and status = 128 )
		      Set @hasid = 1

		   if ( @hasid = 1)
		      Set identity_insert ' + @desttablename + ' on

		   Insert Into ' + @desttablename + ' (' + @columns + ') 
	  	      select ' + @columns + ' from ' + @srctablename + ' 

		   if ( @hasid = 1)
		      Set identity_insert ' + @desttablename + ' off
		end '
	
	Exec sp_executesql @sqltext
end
GO