if exists ( select * from sysobjects where id = object_id ( 'dbo.A_TaskManager_List_ClearIdColumnConstraint' ) )
	Drop procedure dbo.A_TaskManager_List_ClearIdColumnConstraint
GO


Create procedure [dbo].[A_TaskManager_List_ClearIdColumnConstraint]
	@table nvarchar(255), 
	@column nvarchar(255)
as
begin
	declare @c_name nvarchar(255)
	declare @stmt nvarchar(500)
	set @stmt = ''
	if exists 
	( 
		select constraint_name
		from information_schema.CONSTRAINT_COLUMN_USAGE ccu
			inner join sysobjects so on so.name = ccu.table_name
		Where so.id = object_id ( @table )
			and (( @column = '' ) or ( ccu.column_name = @column ))
	) 
	   
        begin

		declare cr cursor local FAST_FORWARD 
			for 
				 select constraint_name
				 from information_schema.CONSTRAINT_COLUMN_USAGE
				 where table_name = @table and  column_name = @column /*and constraint_name like 'PK%'*/
		open cr
		fetch next from cr into @c_name
		while @@fetch_status = 0 begin
			set @stmt = @stmt + 'alter table ' + @table + ' drop constraint ' + @c_name + ' '
			fetch next from cr into @c_name
		end
		close cr
		deallocate cr
		exec sp_executesql @stmt
	end
end
GO
